/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AmazonAdsConnectorForm type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AmazonAdsConnectorForm{}

// AmazonAdsConnectorForm struct for AmazonAdsConnectorForm
type AmazonAdsConnectorForm struct {
	ConnectorId string `json:"connectorId"`
	TemplateId  string `json:"templateId"`
	Strategy    string `json:"strategy"`
	// Enforcing data types
	EnsureDataTypes map[string]interface{} `json:"ensureDataTypes,omitempty"`
	// Authorizer ID
	OAuthId string `json:"oAuthId"`
	// Label of the source
	Label string `json:"label"`
	// Amazon Ads Profile ID
	ProfileId string `json:"profileId"`
	// Amazon Ads Report Category (Ad Product)
	AdProduct string `json:"adProduct"`
	// Amazon Ads Report Type
	ReportType string `json:"reportType"`
	// Amazon Ads Grouping parameter
	GroupBy []string `json:"groupBy,omitempty"`
	// Amazon Ads Time Unit
	TimeUnit *string `json:"timeUnit,omitempty"`
	// Amazon Ads Tactic
	Tactic *string `json:"tactic,omitempty"`
	// Columns
	Column []string `json:"column"`
	// Data range expression
	DateRange string `json:"dateRange"`
}

// NewAmazonAdsConnectorForm instantiates a new AmazonAdsConnectorForm object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAmazonAdsConnectorForm(connectorId string, templateId string, strategy string, oAuthId string, label string, profileId string, adProduct string, reportType string, column []string, dateRange string) *AmazonAdsConnectorForm {
	this := AmazonAdsConnectorForm{}
	this.ConnectorId = connectorId
	this.TemplateId = templateId
	this.Strategy = strategy
	this.OAuthId = oAuthId
	this.Label = label
	this.ProfileId = profileId
	this.AdProduct = adProduct
	this.ReportType = reportType
	this.Column = column
	this.DateRange = dateRange
	return &this
}

// NewAmazonAdsConnectorFormWithDefaults instantiates a new AmazonAdsConnectorForm object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAmazonAdsConnectorFormWithDefaults() *AmazonAdsConnectorForm {
	this := AmazonAdsConnectorForm{}
	return &this
}

// GetConnectorId returns the ConnectorId field value
func (o *AmazonAdsConnectorForm) GetConnectorId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ConnectorId
}

// GetConnectorIdOk returns a tuple with the ConnectorId field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetConnectorIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ConnectorId, true
}

// SetConnectorId sets field value
func (o *AmazonAdsConnectorForm) SetConnectorId(v string) {
	o.ConnectorId = v
}

// GetTemplateId returns the TemplateId field value
func (o *AmazonAdsConnectorForm) GetTemplateId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.TemplateId
}

// GetTemplateIdOk returns a tuple with the TemplateId field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetTemplateIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.TemplateId, true
}

// SetTemplateId sets field value
func (o *AmazonAdsConnectorForm) SetTemplateId(v string) {
	o.TemplateId = v
}

// GetStrategy returns the Strategy field value
func (o *AmazonAdsConnectorForm) GetStrategy() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Strategy
}

// GetStrategyOk returns a tuple with the Strategy field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetStrategyOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Strategy, true
}

// SetStrategy sets field value
func (o *AmazonAdsConnectorForm) SetStrategy(v string) {
	o.Strategy = v
}

// GetEnsureDataTypes returns the EnsureDataTypes field value if set, zero value otherwise.
func (o *AmazonAdsConnectorForm) GetEnsureDataTypes() map[string]interface{} {
	if o == nil || IsNil(o.EnsureDataTypes) {
		var ret map[string]interface{}
		return ret
	}
	return o.EnsureDataTypes
}

// GetEnsureDataTypesOk returns a tuple with the EnsureDataTypes field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetEnsureDataTypesOk() (map[string]interface{}, bool) {
	if o == nil || IsNil(o.EnsureDataTypes) {
		return map[string]interface{}{}, false
	}
	return o.EnsureDataTypes, true
}

// HasEnsureDataTypes returns a boolean if a field has been set.
func (o *AmazonAdsConnectorForm) HasEnsureDataTypes() bool {
	if o != nil && !IsNil(o.EnsureDataTypes) {
		return true
	}

	return false
}

// SetEnsureDataTypes gets a reference to the given map[string]interface{} and assigns it to the EnsureDataTypes field.
func (o *AmazonAdsConnectorForm) SetEnsureDataTypes(v map[string]interface{}) {
	o.EnsureDataTypes = v
}

// GetOAuthId returns the OAuthId field value
func (o *AmazonAdsConnectorForm) GetOAuthId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetOAuthIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.OAuthId, true
}

// SetOAuthId sets field value
func (o *AmazonAdsConnectorForm) SetOAuthId(v string) {
	o.OAuthId = v
}

// GetLabel returns the Label field value
func (o *AmazonAdsConnectorForm) GetLabel() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.Label
}

// GetLabelOk returns a tuple with the Label field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetLabelOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.Label, true
}

// SetLabel sets field value
func (o *AmazonAdsConnectorForm) SetLabel(v string) {
	o.Label = v
}

// GetProfileId returns the ProfileId field value
func (o *AmazonAdsConnectorForm) GetProfileId() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ProfileId
}

// GetProfileIdOk returns a tuple with the ProfileId field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetProfileIdOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ProfileId, true
}

// SetProfileId sets field value
func (o *AmazonAdsConnectorForm) SetProfileId(v string) {
	o.ProfileId = v
}

// GetAdProduct returns the AdProduct field value
func (o *AmazonAdsConnectorForm) GetAdProduct() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.AdProduct
}

// GetAdProductOk returns a tuple with the AdProduct field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetAdProductOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.AdProduct, true
}

// SetAdProduct sets field value
func (o *AmazonAdsConnectorForm) SetAdProduct(v string) {
	o.AdProduct = v
}

// GetReportType returns the ReportType field value
func (o *AmazonAdsConnectorForm) GetReportType() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.ReportType
}

// GetReportTypeOk returns a tuple with the ReportType field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetReportTypeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.ReportType, true
}

// SetReportType sets field value
func (o *AmazonAdsConnectorForm) SetReportType(v string) {
	o.ReportType = v
}

// GetGroupBy returns the GroupBy field value if set, zero value otherwise.
func (o *AmazonAdsConnectorForm) GetGroupBy() []string {
	if o == nil || IsNil(o.GroupBy) {
		var ret []string
		return ret
	}
	return o.GroupBy
}

// GetGroupByOk returns a tuple with the GroupBy field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetGroupByOk() ([]string, bool) {
	if o == nil || IsNil(o.GroupBy) {
		return nil, false
	}
	return o.GroupBy, true
}

// HasGroupBy returns a boolean if a field has been set.
func (o *AmazonAdsConnectorForm) HasGroupBy() bool {
	if o != nil && !IsNil(o.GroupBy) {
		return true
	}

	return false
}

// SetGroupBy gets a reference to the given []string and assigns it to the GroupBy field.
func (o *AmazonAdsConnectorForm) SetGroupBy(v []string) {
	o.GroupBy = v
}

// GetTimeUnit returns the TimeUnit field value if set, zero value otherwise.
func (o *AmazonAdsConnectorForm) GetTimeUnit() string {
	if o == nil || IsNil(o.TimeUnit) {
		var ret string
		return ret
	}
	return *o.TimeUnit
}

// GetTimeUnitOk returns a tuple with the TimeUnit field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetTimeUnitOk() (*string, bool) {
	if o == nil || IsNil(o.TimeUnit) {
		return nil, false
	}
	return o.TimeUnit, true
}

// HasTimeUnit returns a boolean if a field has been set.
func (o *AmazonAdsConnectorForm) HasTimeUnit() bool {
	if o != nil && !IsNil(o.TimeUnit) {
		return true
	}

	return false
}

// SetTimeUnit gets a reference to the given string and assigns it to the TimeUnit field.
func (o *AmazonAdsConnectorForm) SetTimeUnit(v string) {
	o.TimeUnit = &v
}

// GetTactic returns the Tactic field value if set, zero value otherwise.
func (o *AmazonAdsConnectorForm) GetTactic() string {
	if o == nil || IsNil(o.Tactic) {
		var ret string
		return ret
	}
	return *o.Tactic
}

// GetTacticOk returns a tuple with the Tactic field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetTacticOk() (*string, bool) {
	if o == nil || IsNil(o.Tactic) {
		return nil, false
	}
	return o.Tactic, true
}

// HasTactic returns a boolean if a field has been set.
func (o *AmazonAdsConnectorForm) HasTactic() bool {
	if o != nil && !IsNil(o.Tactic) {
		return true
	}

	return false
}

// SetTactic gets a reference to the given string and assigns it to the Tactic field.
func (o *AmazonAdsConnectorForm) SetTactic(v string) {
	o.Tactic = &v
}

// GetColumn returns the Column field value
func (o *AmazonAdsConnectorForm) GetColumn() []string {
	if o == nil {
		var ret []string
		return ret
	}

	return o.Column
}

// GetColumnOk returns a tuple with the Column field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetColumnOk() ([]string, bool) {
	if o == nil {
		return nil, false
	}
	return o.Column, true
}

// SetColumn sets field value
func (o *AmazonAdsConnectorForm) SetColumn(v []string) {
	o.Column = v
}

// GetDateRange returns the DateRange field value
func (o *AmazonAdsConnectorForm) GetDateRange() string {
	if o == nil {
		var ret string
		return ret
	}

	return o.DateRange
}

// GetDateRangeOk returns a tuple with the DateRange field value
// and a boolean to check if the value has been set.
func (o *AmazonAdsConnectorForm) GetDateRangeOk() (*string, bool) {
	if o == nil {
		return nil, false
	}
	return &o.DateRange, true
}

// SetDateRange sets field value
func (o *AmazonAdsConnectorForm) SetDateRange(v string) {
	o.DateRange = v
}

func (o AmazonAdsConnectorForm) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AmazonAdsConnectorForm) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	toSerialize["connectorId"] = o.ConnectorId
	toSerialize["templateId"] = o.TemplateId
	toSerialize["strategy"] = o.Strategy
	if !IsNil(o.EnsureDataTypes) {
		toSerialize["ensureDataTypes"] = o.EnsureDataTypes
	}
	toSerialize["oAuthId"] = o.OAuthId
	toSerialize["label"] = o.Label
	toSerialize["profileId"] = o.ProfileId
	toSerialize["adProduct"] = o.AdProduct
	toSerialize["reportType"] = o.ReportType
	if !IsNil(o.GroupBy) {
		toSerialize["groupBy"] = o.GroupBy
	}
	if !IsNil(o.TimeUnit) {
		toSerialize["timeUnit"] = o.TimeUnit
	}
	if !IsNil(o.Tactic) {
		toSerialize["tactic"] = o.Tactic
	}
	toSerialize["column"] = o.Column
	toSerialize["dateRange"] = o.DateRange
	return toSerialize, nil
}

type NullableAmazonAdsConnectorForm struct {
	value *AmazonAdsConnectorForm
	isSet bool
}

func (v NullableAmazonAdsConnectorForm) Get() *AmazonAdsConnectorForm {
	return v.value
}

func (v *NullableAmazonAdsConnectorForm) Set(val *AmazonAdsConnectorForm) {
	v.value = val
	v.isSet = true
}

func (v NullableAmazonAdsConnectorForm) IsSet() bool {
	return v.isSet
}

func (v *NullableAmazonAdsConnectorForm) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAmazonAdsConnectorForm(val *AmazonAdsConnectorForm) *NullableAmazonAdsConnectorForm {
	return &NullableAmazonAdsConnectorForm{value: val, isSet: true}
}

func (v NullableAmazonAdsConnectorForm) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAmazonAdsConnectorForm) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
